% ARFace_PWCM_01.m
% using L2-norm minimization, Lp-norm comparison (multiple)
% with down-sampling
%% prepare for data 
% close all;
% clear all;

load('ARdata_occluded_results.mat');
% para = [isOSC,isDisplay,isL2norm,scale,isResize,use_face_oval,use_normalization, ]
para  =  [0     0         1        4     0        0             0          ];
% isL2norm = true;scale = 4;isResize = true;use_face_oval = false;newsize = [83,60];
% sub_index = [1:100];training_index = [1,2,3,4,14,15,16,17]; test_index = [8,11,21,24];ARFace_PWCM_01_osc

isOSC = false;             % implement on OSC
isDisplay = false;         % need display detailed
isL2norm = true;           % use L1 or L2 norm to minimize
scale = 4;                 % down sample by scale*scale
isResize = false;           % if need resize the image and mask
use_face_oval = true;      % use oval face mask
use_normalization = false; % use illumination normalization
newsize = [29,21];       % new size of the image is isResize

sub_index = [1:50];        % all males
sub_index = [51:100];      % all females
sub_index = [1:25,51:75];  % first 25 male and first 25 female
sub_index = [1:100];       % all males and females
% sub_index = [1:25];       % all males and females


training_index = [1:7]; test_index = [8:13];
training_index = [1:4]; test_index = [8,11];
training_index = [1,8,11]; test_index = [14];
training_index = [1,2,3,4,8,11]; test_index = [14,15,16,17];
training_index = [1:13]; test_index = [14:20];
training_index = [1:7]; test_index = [14:20];
training_index = [8,11]; test_index = [1,14];
training_index = [1:7]; test_index = [14:20];
training_index = [1,2,3,4,14,15,16,17]; test_index = [8,11,21,24];
training_index = [1,5,6]; test_index = [21:26];
training_index = [1]; test_index = [24];
training_index = [1,2,3,14,15,16]; test_index = [4,8,11,17,21,24];
training_index = [2,3,4]; test_index = [8,11];
training_index = [8,11]; test_index = [2,3,4];
training_index = [8,11,21,24]; test_index = [1,14];
training_index = [8,11]; test_index = [2,3,4,15,16,17];
training_index = [1:13]; test_index = [14:26];
training_index = [8,11]; test_index = [1,14];
training_index = [1]; test_index = [14,15,16,17];
training_index = [1:7]; test_index = [8:26];
training_index = [1]; test_index = [2,3,4];
training_index = [8,11,21,24]; test_index = [2,3,4,15,16,17];
training_index = [1]; test_index = [8,11,21,24];
%%%%%%%%%%%%%%%%
training_index = [1,2,3,8,11]; test_index = [14,15,16,21,24];
training_index = [1,2,3,4]; test_index = [14,15,16,17];
training_index = [1,5,6]; test_index = [8:13,21:26];
training_index = [1]; test_index = [14];
training_index = [1:13]; test_index = [14:26];
% isL2norm = true;scale = 4;isResize = false;use_face_oval = false;newsize = [54,39];
% sub_index = [1:100];training_index = [1,8,11]; test_index = [14,15,16,17];

%%
trainingnum = length(training_index);
if isResize;     scale = 1;  end;
img_width = 156; img_height = 215; 
diff_norm2 = [2, 1.8, 1.6, 1.5, 1.4, 1.2, 1.0, 0.8, 0.6, 0.5, 0.4, 0.2];
diff_norm1 = [1.0, 0.8, 0.6, 0.5, 0.4, 0.2];
if isL2norm
    diff_norm = diff_norm2;
else
    diff_norm = diff_norm1;
end;

%% generate face oval mask (elliptical mask)
if use_face_oval
    oval_mask  = false(img_height,img_width);
    % a = 90; b = 120; xc = 78; yc = 108; % a = 80; b = 110; xc = 78; yc = 108;
    a = 78; b = 107; xc = 78; yc = 108;
    for y = 1 : img_height
        for x = 1 : img_width
            if (x-xc)^2/a^2 + (y-yc)^2/b^2<=1
                oval_mask(y,x) = true;
            end
        end
    end
    oval_mask = oval_mask(1:scale:end,1:scale:end);
    if isResize; oval_mask = imresize(oval_mask,newsize); end;
    oval_mask1 = reshape(oval_mask,[],1);
    oval_index = find(oval_mask1);
else
    oval_mask  = true(img_height,img_width);
    oval_mask = oval_mask(1:scale:end,1:scale:end);
    if isResize; oval_mask = imresize(oval_mask,newsize); end;
    oval_mask1 = reshape(oval_mask,[],1);
    oval_index = find(oval_mask1);
end;
image_size = length(oval_index);
%%
trainingdata_all = single(zeros(image_size, length(sub_index)*length(training_index)));
INC_all = zeros(image_size, length(sub_index)*length(training_index));
non_occluded_index = [1:7,14:20]; occluded_index = [8:13, 21:26]; sample_index = [1:26];
%% collect data to get training data set
if ~isOSC
    imagefolder = 'ARCrop\'; occlusionfolder = 'AROcclusion\';
else
    imagefolder = 'ARCrop/'; occlusionfolder = 'AROcclusion/';
end;
loaddata = 0;
image_index = 0;
if loaddata == 0
    for ii = 1 : length(sub_index)
        sub = sub_index(ii)
        for index = training_index;
            index;
            if sub<=50
                filename = [imagefolder,'M-',num2str(sub,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
            else
                filename = [imagefolder,'W-',num2str(sub-50,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
            end;
            im = imread(filename);
            im = im(1:scale:end,1:scale:end,:); % down sampling
            im2 = single(rgb2gray(im))/256; 
            if isResize; im2 = imresize(im2,newsize); end;
            im2 = reshape(im2,[],1); %im2 = im2 - ones(size(im2))*mean(im2);
            im2 = im2(oval_index); % include face oval effect
            if ismember(index,occluded_index)
                occluded1 = occludedregion{sub,index};
            else
                occluded1 = false(img_height,img_width);
            end;
            occluded1 = occluded1(1:scale:end,1:scale:end);        % down sampling
            if isResize; occluded1 = imresize(occluded1,newsize); end;
            occluded1_1 = reshape(occluded1,[],1);        % reshape to a column
            occluded1_1 = occluded1_1(oval_index); % include face oval effect
            % subtract some illumination effect by unit std, zero mean
            if use_normalization
                seen_index = find(~occluded1_1);
                im2_mean = mean(im2(seen_index)); im2_std = std(im2(seen_index));
                im2 = (im2 - ones(size(im2))*im2_mean)/im2_std;
            end;
            image_index = image_index+1;
            trainingdata_all(:,image_index) = im2.*(1-occluded1_1);
            INC_all(:,image_index) = 1-occluded1_1;
        end
    end;

    label_all = zeros(image_size,length(sub_index));
    for j = 1 : length(sub_index)
        INC = INC_all(:,trainingnum*(j-1)+1:trainingnum*j);
        label = bin2dec(int2str(logical(INC)));
        label_all(:,j) = label;
    end;
else
    load('20080306_1_13.mat');
end;

%% test: generate occluded mask
% occluded1 = zeros(img_height, img_width);
% occluded3 = zeros(img_height, img_width, 3);
% % down sampling
% occluded1 = zeros((img_height+1)/2, img_width/2);
% occluded3 = zeros((img_height+1)/2, img_width/2, 3);
% occluded = cell(length(sub_index),length(image_index));
result = cell(length(diff_norm),1);
for ii = 1:length(sub_index)
    sub = sub_index(ii)
    for index = test_index
        index;
        if ismember(index,[8:13,21:26])
            occluded1 = occludedregion{sub,index};
        else
            occluded1 = false(img_height,img_width);
        end;
        occluded1 = occluded1(1:scale:end,1:scale:end); % down sampling
        if isResize; occluded1 = imresize(occluded1,newsize); end;
        occluded1_1 = reshape(occluded1,[],1); % reshape to a column
        occluded1_1 = occluded1_1(oval_index); % include face oval effect
        if sub<=50
            filename = [imagefolder,'M-',num2str(sub,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
        else
            filename = [imagefolder,'W-',num2str(sub-50,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
        end;
        im = imread(filename);
        im = im(1:scale:end,1:scale:end,:); % down sampling
        im2 = single(rgb2gray(im))/256; 
        if isResize; im2 = imresize(im2,newsize); end;
        dim = size(im2); im2 = reshape(im2,[],1);
        im2 = im2(oval_index); % include face oval effect
        % subtract some illumination effect by unit std, zero mean
        if use_normalization
            seen_index = find(~occluded1_1);
            im2_mean = mean(im2(seen_index)); im2_std = std(im2(seen_index));
            im2 = (im2 - ones(size(im2))*im2_mean)/im2_std;
        end;
        INC_cur = 1-occluded1_1; % 0 for occluded, 1 for seen

        test_cur = im2(~occluded1_1);
        trainingdata_all_cur = trainingdata_all(~occluded1_1,:);
        INC_all_cur = INC_all(~occluded1_1,:);
        dist = zeros(length(sub_index),length(diff_norm));
        for j = 1:length(sub_index)
            if isDisplay
                if size(result{1},1)>0
                    matchresult = [];
                    for k = 1 : length(diff_norm)
                        matchresult(k,1) = length(find(result{k}(:,1)-result{k}(:,2)==0))/size(result{k},1);
                    end;
                    [sub,index,j,matchresult']
                else
                    [sub,index,j,0]
                end;
            end;
            A = trainingdata_all_cur(:,trainingnum*(j-1)+1:trainingnum*j);
            INC = INC_all_cur(:,trainingnum*(j-1)+1:trainingnum*j);
            % label = bin2dec(int2str(logical(INC)));
            label = label_all(~occluded1_1,j);
            class = union(label,[]);
            diff = zeros(size(test_cur));
            for i = 1 : length(class)
                class_cur = class(i);
                class_index = find(label==class_cur);
                sample_index = find(dec2bin(class_cur)=='1');
                A_part = A(class_index,sample_index);
                test_cur_part = test_cur(class_index);
                if length(class_index)<length(sample_index)
                    diff(class_index) = 0;
                elseif rank(A_part)<min(size(A_part))% det(A_part'*A_part)<
                    diff(class_index) = 0;
                else
                    if isL2norm
                        % use L2-norm
                        test_cur_part_est = A_part*(inv(A_part'*A_part)*(A_part'*test_cur_part));
                    else
                        % use L1-norm
                        x0 = inv(A_part'*A_part)*(A_part'*test_cur_part); % initialized as L2 norm minimizor
                        xp = l1decode_pd_jia(x0, A_part, [], test_cur_part, 1e-4, 30);
                        test_cur_part_est = A_part*xp;
                    end;
                    diff(class_index) = test_cur_part - test_cur_part_est;
                end;
            end;
            for k = 1 : length(diff_norm)
                dist(j,k) = norm(diff,diff_norm(k));
            end;
        end;
        for k = 1 : length(diff_norm)
            [dist_sort,IX] = sort(dist(:,k));
            result{k} = [result{k};[ii,IX']];
        end;
        matchresult = [];
        for k = 1 : length(diff_norm)
            matchresult(k,1) = length(find(result{k}(:,1)-result{k}(:,2)==0))/size(result{k},1);
        end;
        [sub,index,matchresult']
    end;
end;
%     length(find(result(:,1)-result(:,2)==0))
match = [];
matchsub = [];
matchcondition = [];
for k = 1 : length(diff_norm)
    match = result{k}(:,1)==result{k}(:,2);
    match = reshape(match,length(test_index),[]);
    matchsub(k,:)=sum(match);
    matchcondition(k,:)=sum(match');
end;
matchresult = [];
for k = 1 : length(diff_norm)
    matchresult(k,1) = length(find(result{k}(:,1)-result{k}(:,2)==0))/size(result{k},1);
    matchresult(k,2) = length(find(result{k}(:,1)-result{k}(:,2)==0));
end;

matchresult'

currenttime = datestr(now);
currenttime = currenttime(currenttime~=':')
save(['2008_all_',currenttime,'.mat'],'result','match','matchsub','matchcondition','matchresult',...
'scale','use_face_oval','use_normalization','diff_norm','isOSC','isDisplay','isL2norm','isResize','newsize',...
'sub_index','training_index','test_index');

matchresult([1,7,10],:)
matchcondition([1,7,10],:)

return;




%% return;